import java.util.*;
import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;
import com.nokia.mid.ui.*;
import javax.microedition.media.*;
import java.io.*;

interface AlarmCallBack {
  void onDefused();
  void onWrongCode();
  void onExplode();
}


class AlarmScreen extends Canvas {
  private Image bombImage;
  
  private int iHour;
  private int iMinute;
  private int iSecond;
  private int iYear;
  private int iMonth;
  private int iDate;
  private int iDow;
  private int secondsUntilDetonation;
  
  private int textColor = 0x00ffffff;
  private int timeColor = 0x00ffffff;
  private int backColor = 0x007F0000;
  
  private String strCode = "";
  
  private AlarmCallBack alarmCallback = null;
  
  /* Constructor */
  public AlarmScreen(AlarmCallBack alarmCallback){
    try{
      bombImage = Image.createImage("/LaBomba.png");
    } catch (Exception e){
      e.printStackTrace();
    }
    this.alarmCallback = alarmCallback;
  }  
  
  protected void keyPressed(int keyCode){
    
    if (keyCode > 0) {
      strCode = strCode + ((char) keyCode);
      if (strCode.length() > BombConfig.defuseCode.length()) {
        strCode = strCode.substring(1, 4);
      }
      //System.out.println(strCode);
      if (strCode.length() == BombConfig.defuseCode.length()) {
        if (strCode.equals(BombConfig.defuseCode)) {
          if (null != alarmCallback) {
            alarmCallback.onDefused();
          }
          cleanUp();
        } else {
          alarmCallback.onWrongCode();
          if (strCode.endsWith(BombConfig.defuseCode.substring(0, 2))){
            strCode = BombConfig.defuseCode.substring(0, 2);
          } else if (strCode.endsWith(BombConfig.defuseCode.substring(0, 1))){
            strCode = BombConfig.defuseCode.substring(0, 1);
          } else {
            cleanUp();
          }
        }
      }
    }
  }
  
  public void cleanUp(){
    strCode = "";
  }
  
  
  public int drawRemainingTime(Graphics g, int x, int y){
    int sw = getWidth();
    
    int digitCount = 2;
    int xDotCount = 5; // 5 columns per digit
    
    int pw = (sw - 2 * x) / (xDotCount * digitCount);
    int ph = pw;
    
    int digitWidth = pw * xDotCount;
    
    BombUtils.drawDigit(g, x, y, pw, ph, secondsUntilDetonation / 10, timeColor, backColor);
    BombUtils.drawDigit(g, x+digitWidth, y, pw, ph, secondsUntilDetonation % 10, timeColor, backColor);
    
    return (ph*7);
  }  
  
  public void setRemainingTime(int secondsUntilDetonation){
    this.secondsUntilDetonation = secondsUntilDetonation;
  }
  
  public void paint(Graphics g) {
    int topSpace = 20;
    int ySpace = 10;
    
    int width = getWidth();
    int height = getHeight();
    
    int colorBlack = 0x00000000;
    int colorWhite = 0x00ffffff;
    
    int y = topSpace;
    
    Font font = g.getFont();

    g.setColor(backColor);
    g.fillRect(0, 0, width, height);
    
    Font bigTextFont = Font.getFont(Font.FACE_PROPORTIONAL, Font.STYLE_BOLD, Font.SIZE_LARGE);
    Font normalTextFont = Font.getFont(Font.FACE_SYSTEM, Font.STYLE_PLAIN, Font.SIZE_MEDIUM);
    Font largeTextFont = Font.getFont(Font.FACE_SYSTEM, Font.STYLE_PLAIN, Font.SIZE_LARGE);
    Font timeTextFont = Font.getFont(Font.FACE_MONOSPACE, Font.STYLE_BOLD, Font.SIZE_LARGE);
    
    String strRemaining = "" + secondsUntilDetonation;
    
    int timeHeight = drawRemainingTime(g, 45, y);
    y += timeHeight + ySpace;
    
    g.setColor(textColor);
    g.setFont(normalTextFont);
    g.drawString("Enter code to deactivate:", getWidth() / 2, y, Graphics.TOP | Graphics.HCENTER);
    y += normalTextFont.getHeight() + ySpace;
    
    g.drawImage(bombImage, getWidth() / 2, getHeight(), Graphics.BOTTOM | Graphics.HCENTER);
    
    g.setColor(colorWhite);
    int padding = 5; // padding in pixels
    int rWidth = timeTextFont.stringWidth("1234") + padding*2;
    int rHeight = timeTextFont.getHeight() + padding*2;
    int sWidth = timeTextFont.stringWidth(strCode);
    g.fillRect((getWidth() - rWidth)/2 , y, rWidth, rHeight);
    g.setColor(colorBlack);
    g.setFont(timeTextFont);  
    g.drawString(strCode, getWidth() / 2, y+padding, Graphics.TOP | Graphics.HCENTER);
    y += rHeight;
    
    //g.setColor(255, 255, 255);
    //g.drawString(dateStr, 0, font.getHeight()*2, Graphics.TOP | Graphics.LEFT);    
  }
  
} 

