import java.util.*;
import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;
import com.nokia.mid.ui.*;

class BombConfig{
  
  public static final long snoozeDuration = 300L;       // 300s == 5 minutes
  public static final int timerInterval = 500;          // 500ms
  public static final int countDownTime = 30;           // duration in seconds to defuse the bomb
  public static final long penaltyTime = 5L;            // penalty time when entering a wrong code
  public static final String defuseCode = "007";        // must be exactly three digits
  public static final String laBombaVersion = "V1.0";   // version number displayed in lower right corner of ClockScreen

  private AlarmTime[] alarmTimes = {new AlarmTime("Mo"), new AlarmTime("Tu"), new AlarmTime("We"), new AlarmTime("Th"), new AlarmTime("Fr"), new AlarmTime("Sa"), new AlarmTime("Su")};

  public BombConfig() {
  }
  
  public void saveConfig(){
    for (int i=0;i<alarmTimes.length;i++){
      alarmTimes[i].save();
    }
  }
  
  public void loadConfig(){
    for (int i=0;i<alarmTimes.length;i++){
      alarmTimes[i].load();
    }
  }  
  
  public int getAlarmTimeHour(int index){
    if ((index >= 0) && (index < alarmTimes.length)){
      return alarmTimes[index].hour();
    } else {
      return -1;
    }
  }  

  public int getAlarmTimeMinute(int index){
    if ((index >= 0) && (index < alarmTimes.length)){
      return alarmTimes[index].minute();
    } else {
      return -1;
    }
  }  

  
  public AlarmTime getAlarmTime(int index){
    if ((index >= 0) && (index < alarmTimes.length)){
      return alarmTimes[index];
    } else {
      return null;
    }
  }
  
  public boolean setAlarmTime(int index, int hour, int minute){
    if ((index >= 0) && (index < alarmTimes.length)){
      alarmTimes[index].set(hour, minute);
      return true;
    } else {
      return false;
    }
  }  
  
  public boolean setAlarmTime(int index, Date aDate){
    if ((index >= 0) && (index < alarmTimes.length)){
      Calendar cal = Calendar.getInstance(TimeZone.getDefault());
      cal.setTime(aDate);
      return setAlarmTime(index, cal.get(Calendar.HOUR_OF_DAY), cal.get(Calendar.MINUTE));
    } else {
      return false;
    }
  }  
  
  public boolean getAlarmEnableFlag(int index){
    if ((index >= 0) && (index < alarmTimes.length)){
      return alarmTimes[index].isEnabled();
    } else {
      return false;
    }
  }
  
  public boolean setAlarmEnableFlag(int index, boolean isEnabled){
    if ((index >= 0) && (index < alarmTimes.length)){
      alarmTimes[index].set(isEnabled);
      return true;
    } else {
      return false;
    }
  }
  
}
