import java.util.*;
import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;
import com.nokia.mid.ui.*;

class ClockScreen extends Canvas{
  private Image bombImage;
  
  private int iHour;
  private int iMinute;
  private int iSecond;
  private int iYear;
  private int iMonth;
  private int iDate;
  private int iDow;
  private String[] detonationStrings = {"", ""};
  private AlarmCallBack alarmCallback = null;
  
  private int textColor = 0x00ffffff;
  private int timeColor = 0x00A3E4FF;
  private int versionColor = 0x00444444;
  private int backColor = 0x00000000;
  
  private String strCode = "";
  
  /* Constructor */
  public ClockScreen(AlarmCallBack alarmCallback){
    try{
      bombImage = Image.createImage("/LaBomba.png");
    } catch (Exception e){
      e.printStackTrace();
    }
    this.alarmCallback = alarmCallback;
  }
  
  protected void keyPressed(int keyCode){
    if (keyCode > 0) {
      strCode = strCode + ((char) keyCode);
      if (strCode.length() > BombConfig.defuseCode.length()) {
        strCode = strCode.substring(1, 4);
      }
      //System.out.println(strCode);
      if (strCode.length() == BombConfig.defuseCode.length()) {
        if (strCode.equals(BombConfig.defuseCode)) {
          if (null != alarmCallback) {
            alarmCallback.onDefused();
          }
          cleanUp();
        } else {
          //alarmCallback.onWrongCode();
          if (strCode.endsWith(BombConfig.defuseCode.substring(0, 2))){
            strCode = BombConfig.defuseCode.substring(0, 2);
          } else if (strCode.endsWith(BombConfig.defuseCode.substring(0, 1))){
            strCode = BombConfig.defuseCode.substring(0, 1);
          } else {
            cleanUp();
          }
        }
      }
    }
  }
  
  public void cleanUp(){
    strCode = "";
  }  
  
  public void setDateTime(int iHour, int iMinute, int iSecond, int iYear, int iMonth, int iDate, int iDow){
    this.iHour = iHour;
    this.iMinute = iMinute;
    this.iSecond = iSecond;
    this.iYear = iYear;
    this.iMonth = iMonth;
    this.iDate = iDate;
    this.iDow = iDow;
  }
  
  public void setDetonationString(String detonationString1, String detonationString2){
    this.detonationStrings[0] = detonationString1;
    this.detonationStrings[1] = detonationString2;
  }
  
  
  public int drawTime(Graphics g, int x, int y){
    int sw = getWidth();
    
    //int digitCount = 8; // 12:34:56 = 6 digits + : + : = 8
    int digitCount = 5; // 12:34 = 4 digits + : = 5
    int xDotCount = 5; // 5 columns per digit
    
    int pw = (sw - 2 * x) / (xDotCount * digitCount);
    int ph = pw;
    
    int digitWidth = pw * xDotCount;
    
    BombUtils.drawDigit(g, x, y, pw, ph, this.iHour / 10, timeColor, backColor);
    BombUtils.drawDigit(g, x+digitWidth, y, pw, ph, this.iHour % 10, timeColor, backColor);
    BombUtils.drawDigit(g, x+digitWidth*2, y, pw, ph, 10, timeColor, backColor);
    BombUtils.drawDigit(g, x+digitWidth*3, y, pw, ph, this.iMinute / 10, timeColor, backColor);
    BombUtils.drawDigit(g, x+digitWidth*4, y, pw, ph, this.iMinute % 10, timeColor, backColor);
    /*
    BombUtils.drawDigit(g, x+digitWidth*5, y, pw, ph, 10, timeColor, backColor);
    BombUtils.drawDigit(g, x+digitWidth*6, y, pw, ph, this.iSecond / 10, timeColor, backColor);
    BombUtils.drawDigit(g, x+digitWidth*7, y, pw, ph, this.iSecond % 10, timeColor, backColor);
    */
    
    return (ph*7);
  }

  public void paint(Graphics g) {
    int topSpace = 20;
  
    int width = getWidth();
    int height = getHeight();
    Font font = g.getFont();

    g.setColor(backColor);
    g.fillRect(0, 0, width, height);
    
    //g.drawImage(bombImage, getWidth() / 2, getHeight() / 2, Graphics.HCENTER | Graphics.VCENTER);
    
    Font bigTextFont = Font.getFont(Font.FACE_PROPORTIONAL, Font.STYLE_BOLD, Font.SIZE_LARGE);
    Font normalTextFont = Font.getFont(Font.FACE_SYSTEM, Font.STYLE_PLAIN, Font.SIZE_MEDIUM);
    Font largeTextFont = Font.getFont(Font.FACE_SYSTEM, Font.STYLE_PLAIN, Font.SIZE_LARGE);
    Font smallTextFont = Font.getFont(Font.FACE_MONOSPACE, Font.STYLE_PLAIN, Font.SIZE_LARGE);
    
    Font timeTextFont = Font.getFont(Font.FACE_MONOSPACE, Font.STYLE_BOLD, Font.SIZE_LARGE);
    
    String strDate = BombUtils.addLeadingZeros(iDate, 2)+"."+BombUtils.addLeadingZeros(iMonth, 2)+".";
    String strTime = BombUtils.addLeadingZeros(iHour, 2)+":"+BombUtils.addLeadingZeros(iMinute, 2)+":"+BombUtils.addLeadingZeros(iSecond, 2);
    
    g.setColor(textColor);
    g.setFont(bigTextFont);    
    g.drawString(BombUtils.dowToDayName(iDow), getWidth() / 2, topSpace, Graphics.TOP | Graphics.HCENTER);
    g.setFont(largeTextFont);  
    g.drawString(strDate , getWidth() / 2, topSpace + bigTextFont.getHeight(), Graphics.TOP | Graphics.HCENTER);
    //g.setFont(timeTextFont);  
    //g.drawString(strTime, getWidth() / 2, topSpace*3 + bigTextFont.getHeight() + largeTextFont.getHeight(), Graphics.TOP | Graphics.HCENTER);
    
    int timeHeight = drawTime(g, 7, topSpace + bigTextFont.getHeight() + largeTextFont.getHeight() + timeTextFont.getHeight());
    
    g.setFont(normalTextFont);
    g.setColor(textColor);
    g.drawString(this.detonationStrings[0], 7, timeHeight + topSpace*3 + bigTextFont.getHeight() + largeTextFont.getHeight() + timeTextFont.getHeight(), Graphics.TOP | Graphics.LEFT);
    g.drawString(this.detonationStrings[1], 7, timeHeight + topSpace*4 + bigTextFont.getHeight() + largeTextFont.getHeight() + timeTextFont.getHeight(), Graphics.TOP | Graphics.LEFT);
    
    
    g.setFont(normalTextFont);
    g.setColor(versionColor);
    g.drawString(BombConfig.laBombaVersion, getWidth() - smallTextFont.stringWidth(BombConfig.laBombaVersion) - 4 , getHeight() - smallTextFont.getHeight() - 4, Graphics.TOP | Graphics.LEFT);
    
    //g.setColor(255, 255, 255);
    //g.drawString(dateStr, 0, font.getHeight()*2, Graphics.TOP | Graphics.LEFT);    
  }
  
} 

