import java.util.*;
import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;
import com.nokia.mid.ui.*;
import javax.microedition.media.*;
import java.io.*;


public class LaBomba extends MIDlet implements CommandListener, AlarmCallBack{
  private Display disp;
  Calendar bombCalendar = Calendar.getInstance(TimeZone.getDefault());
  private Timer timer;
  private BombTimerTask aBombTimerTask;
  private BombConfig bombConfig;
  
  private long snoozeTime = 0L;
  private long penalty = 0L;
  private boolean isDefused = false;
  
  private Player boomPlayer = null;
  private Player wrongcodePlayer = null;
  
  private long boomScreenDisplayedDuration = 0L;
  
  private long lastSecondsUntilDetonation = -1;
  
  
  /* Commands */
  private Command cmdConfig;
  private Command cmdExit;
  private Command cmdBackToClock;
  private Command cmdEditTime;
  private Command cmdConfirmTime;
  private Command cmdBackToConfig;
  private Command cmdSelect;
  private Command cmdSnooze;
  private Command cmdStop;

  /* Screens */
  private ConfigurationForm configurationForm;
  private TimeEditForm timeEditForm;
  private ClockScreen clockScreen;
  private AlarmScreen alarmScreen;
  private BoomScreen boomScreen;
  
  public void onDefused(){
    if (!isDefused) {
      //System.out.println("Defused!");
      snoozeTime = 0L;
      penalty = 0L;
      isDefused = true;
      disp.setCurrent(clockScreen);
      
      try {
        InputStream in = getClass().getResourceAsStream("/defused.mp3");
        Player defusePlayer = Manager.createPlayer(in, "audio/mpeg");
        defusePlayer.start();
      } catch (Exception ex) {
        try {
          Manager.playTone(70, 500, 100);
        } catch (Exception e){
          e.printStackTrace();
        }
      }
      
    }
  }

  public void onWrongCode(){
    //System.out.println("Wrong Code!");
    
    try {
      wrongcodePlayer.start();
    } catch (Exception ex) {
      ex.printStackTrace();
    }
    
    penalty += BombConfig.penaltyTime;
    
  }
  
  public void onExplode(){
    //System.out.println("BOOOOM!");
    if (boomScreen != disp.getCurrent()){
      boomScreenDisplayedDuration = 0L;
      disp.setCurrent(boomScreen);
      try {
        boomPlayer.start();
      } catch (Exception ex) {
        try {
          Manager.playTone(60, 500, 100);
        } catch (Exception e){
          e.printStackTrace();
        }
      }
    }

  }
  
  public void timerTick(){
    Date aDate;
    TimeZone tz;
    int hour, minute, second, milis, dow, dom, month, year;
    long offset = 0;
    
    aDate = new Date();
    tz = bombCalendar.getTimeZone();
    offset = tz.getRawOffset();
    bombCalendar.setTime(new Date(aDate.getTime() + offset));
    
    milis   = bombCalendar.get(Calendar.MILLISECOND);
    second  = bombCalendar.get(Calendar.SECOND);
    minute  = bombCalendar.get(Calendar.MINUTE);
    hour    = bombCalendar.get(Calendar.HOUR_OF_DAY);
    dow     = bombCalendar.get(Calendar.DAY_OF_WEEK);
    dom     = bombCalendar.get(Calendar.DATE);
    month   = bombCalendar.get(Calendar.MONTH)+1;
    year    = bombCalendar.get(Calendar.YEAR);
    
    clockScreen.setDateTime(hour, minute, second, year, month, dom, dow);    
    DeviceControl.setLights(0, 100);
    
    long nowTime = second + minute*60L + hour*3600L;
    long bombTime = 0L;
    
    int atHour = 0;
    int atMinute = 0;
    
    long secondsUntilDetonation = 0L;  
    
    boolean isDetonationToday = false;
    boolean isNextDetonationDay = false;
    
    boolean isSnoozed = false;
    if (snoozeTime > 0) {
      isSnoozed = true;
    }
    
    // check if the alarm is enabled for today
    int alarmIndex =  BombUtils.dowToIndex(dow);
    if (true == bombConfig.getAlarmEnableFlag(alarmIndex)){
      isDetonationToday = true;
      atHour = bombConfig.getAlarmTimeHour(alarmIndex);
      atMinute = bombConfig.getAlarmTimeMinute(alarmIndex);
      bombTime = atMinute*60 + atHour*3600;
      
      secondsUntilDetonation = (bombTime - nowTime) + snoozeTime;
      
      // subtract penalty time, but make sure secondsUntilDetonation won't become negative
      
      if (secondsUntilDetonation >= penalty){
        secondsUntilDetonation -= penalty;
      } else {
        if (secondsUntilDetonation > 0){
          secondsUntilDetonation = 0;
        }
      }
      
      
      if (secondsUntilDetonation < 0) {
        // todays detonation is over
        isDetonationToday = false;
        isDefused = false; // activate it
        alarmScreen.cleanUp();
        clockScreen.cleanUp();
      } else if (secondsUntilDetonation == 0){
        if (false == isDefused){
          this.onExplode();
        }
      } else {
        // Jay! We are bombing today!
        if ((secondsUntilDetonation <= BombConfig.countDownTime) && (!isDefused)) {
          // Jay! We are bombing in a few seconds!
          if (alarmScreen != disp.getCurrent()){
            disp.setCurrent(alarmScreen);
          }
          alarmScreen.setRemainingTime((int)secondsUntilDetonation);
          
          if ((null == wrongcodePlayer) || (wrongcodePlayer.getState() != Player.STARTED)){
            if (lastSecondsUntilDetonation != secondsUntilDetonation) { // play a tone only once every second
              lastSecondsUntilDetonation = secondsUntilDetonation;
              
              int maxNote = 95;
              int startNote = 65;
              int noteCount = maxNote - startNote;
              double noteIncrease = (double)noteCount / (double)BombConfig.countDownTime;
              double note = (double)(BombConfig.countDownTime - secondsUntilDetonation) * noteIncrease + (double)startNote;
              
              try {
                Manager.playTone((int)note, 400, 100);
              } catch (Exception e){
                e.printStackTrace();
              }
            }
          }
          
        }
      }
    }
    
    if (false == isDetonationToday){
      isDefused = false;
      alarmScreen.cleanUp();
      clockScreen.cleanUp();
      
      // search for next detonation day
      secondsUntilDetonation = 24L * 3600L - nowTime;
      for (int i=0;i<7;i++){
        int ai = alarmIndex+i+1;
        if (ai >= 7){ ai = ai - 7;}
        if (true == bombConfig.getAlarmEnableFlag(ai)){
          atHour = bombConfig.getAlarmTimeHour(ai);
          atMinute = bombConfig.getAlarmTimeMinute(ai);
          bombTime = atMinute*60L + atHour*3600L;
          secondsUntilDetonation += bombTime;
          isNextDetonationDay = true;
          break;
        }
        secondsUntilDetonation += 24L * 3600L;
      }
    }
    
    
    String strRemaining = "";
    
    int rHours    = (int)(secondsUntilDetonation/3600L);
    int rMinutes  = (int)(secondsUntilDetonation/60L%60L);
    int rSeconds  = (int)(secondsUntilDetonation%60L);
    
    strRemaining = "Detonation in " + BombUtils.addLeadingZeros(rHours, 2) + ":" + BombUtils.addLeadingZeros(rMinutes, 2) + ":" + BombUtils.addLeadingZeros(rSeconds, 2);
    
    String clockString1 = "";
    String clockString2 = "";
    
    if (isNextDetonationDay){
      clockString1 = "";
      clockString2 = strRemaining;
    } else if (isDetonationToday){
      if (!isDefused){
        if (isSnoozed) {
          clockString1 = "Detonation delayed...";
        }
        clockString2 = strRemaining;
      } else {
        // is defused
        clockString1 = "Bomb has been defused!";
      }
    } else {
      clockString1 = "";
      clockString2 = "";
    }
    
    clockScreen.setDetonationString(clockString1, clockString2);
    
    alarmScreen.repaint();
    clockScreen.repaint();
    
    
    
    if (null != disp){
      if (boomScreen == disp.getCurrent()){
        boomScreenDisplayedDuration += BombConfig.timerInterval;
        if (boomScreenDisplayedDuration >= ((long)BombConfig.snoozeDuration * 1000L)) {
          snoozeTime = 0;
          penalty = 0L;
          isDefused = true;
          disp.setCurrent(clockScreen);
          try {
            InputStream in = getClass().getResourceAsStream("/timeout.mp3");
            Player defusePlayer = Manager.createPlayer(in, "audio/mpeg");
            defusePlayer.start();
          } catch (Exception ex) {
            try {
              Manager.playTone(80, 500, 100);
            } catch (Exception e){
              e.printStackTrace();
            }
          }
        }
      }
    }
    
// DEBUG
    /*
    if (second % 5 == 0){
      System.out.println("#### DEBUG ###");
      System.out.println("isDefused: "+isDefused);
      System.out.println("isSnoozed: "+isSnoozed + " (" + snoozeTime + ")");
      System.out.println("penalty: "+penalty);
      System.out.println("isDetonationToday: "+isDetonationToday);
      System.out.println("isNextDetonationDay: "+isNextDetonationDay);
      System.out.println("secondsUntilDetonation: "+secondsUntilDetonation);
      System.out.println("boomScreenDisplayedDuration: "+boomScreenDisplayedDuration);
      System.out.println("");
    }
    */
// DEBUG
    
    
    
  }

  public LaBomba(){
    /* Init items */
    bombConfig = new BombConfig();
    timer = new Timer();
    aBombTimerTask = new BombTimerTask(this);
    
    try {
      InputStream inLB = getClass().getResourceAsStream("/laBomba.mp3");
      boomPlayer = Manager.createPlayer(inLB, "audio/mpeg");
      boomPlayer.prefetch();
    } catch (Exception ex) {
      ex.printStackTrace();
    }
    
    /*
    // outcommented because it seems the Nokia 6300 does not support playing two sounds at a time
    try {
      InputStream inWC = getClass().getResourceAsStream("/wrongcode.wav");
      wrongcodePlayer = Manager.createPlayer(inWC, "audio/x-wav");
      wrongcodePlayer.prefetch();
    } catch (Exception ex) {
      ex.printStackTrace();
    }    
    */
    
    /* Screens */
    configurationForm = new ConfigurationForm("Config");
    timeEditForm = new TimeEditForm("Time Edit");
    clockScreen = new ClockScreen(this);
    alarmScreen = new AlarmScreen(this);
    boomScreen = new BoomScreen();
    
    /* Commands */
    cmdExit         = new Command("Exit",   Command.EXIT,   2);
    cmdConfig       = new Command("Config", Command.SCREEN, 1);
    cmdBackToClock  = new Command("Back",   Command.BACK,   2);
    cmdBackToConfig = new Command("Abort",  Command.CANCEL, 2);
    cmdEditTime     = new Command("Edit",   Command.SCREEN, 1);
    cmdConfirmTime  = new Command("OK",     Command.SCREEN, 1);
    cmdSelect       = new Command("Select", Command.ITEM,   1);
    cmdSnooze       = new Command("Snooze", Command.SCREEN, 1);
    cmdStop         = new Command("Stop",   Command.SCREEN, 0);
   
    timer.schedule(aBombTimerTask, 0, BombConfig.timerInterval);
  }
  
  public void startApp(){
    
    /* Screen setup */
    
    clockScreen.addCommand(cmdExit);
    clockScreen.addCommand(cmdConfig);
    clockScreen.setFullScreenMode(true);
    clockScreen.setCommandListener(this);
    
    alarmScreen.addCommand(cmdSnooze);
    alarmScreen.setFullScreenMode(true);
    alarmScreen.setCommandListener(this);
    
    boomScreen.addCommand(cmdSnooze);
    boomScreen.addCommand(cmdStop);
    boomScreen.setFullScreenMode(true);
    boomScreen.setCommandListener(this);
    
    configurationForm.addCommand(cmdBackToClock);
    configurationForm.addCommand(cmdEditTime);
    configurationForm.setCommandListener(this);
    configurationForm.setSelectCommand(cmdSelect);
    updateConfigListItems();

    
    timeEditForm.addCommand(cmdBackToConfig);
    timeEditForm.addCommand(cmdConfirmTime);
    timeEditForm.setCommandListener(this);
    
    disp = Display.getDisplay(this);
    
//DEBUG
    /*
    int dow = bombCalendar.get(Calendar.DAY_OF_WEEK);
    int alarmIndex =  BombUtils.dowToIndex(dow);
    Date aDate = new Date();
    bombConfig.setAlarmTime(alarmIndex, new Date(aDate.getTime() + 72000));
    updateConfigListItems();
    */
//DEBUG
    
    disp.setCurrent(clockScreen);
  }

  public void pauseApp(){}

  public void destroyApp(boolean uncond){}

  public void commandAction(Command cmd, Displayable s){
    if (cmd == cmdExit){
      notifyDestroyed();
    }else if (cmd == cmdConfig){
      disp.setCurrent(configurationForm);
    } else if (cmd == cmdSelect){
      int i = configurationForm.getCurrentIndex();
      bombConfig.setAlarmEnableFlag(i, !bombConfig.getAlarmEnableFlag(i));
      updateConfigListItems();
      bombConfig.saveConfig();
      snoozeTime = 0L;
      penalty = 0;
    }else if (cmd == cmdConfirmTime){
      int i = configurationForm.getCurrentIndex();
      Date aDate = timeEditForm.getDate();
      bombConfig.setAlarmTime(i, aDate);
      updateConfigListItems();
      bombConfig.saveConfig();
      disp.setCurrent(configurationForm);
    }else if (cmd == cmdEditTime){
      Calendar cal = Calendar.getInstance(TimeZone.getDefault());
      int i = configurationForm.getCurrentIndex();
      AlarmTime at = bombConfig.getAlarmTime(i);
      cal.set(Calendar.HOUR_OF_DAY, at.hour());
      cal.set(Calendar.MINUTE, at.minute());
      timeEditForm.setDate(cal.getTime());
      timeEditForm.setTitle(BombUtils.weekDayNames[i]);
      disp.setCurrent(timeEditForm);
    }else if (cmd == cmdBackToClock){
      disp.setCurrent(clockScreen);
    }else if (cmd == cmdBackToConfig){
      updateConfigListItems();
      disp.setCurrent(configurationForm);
    }else if (cmd == cmdSnooze){
      snoozeTime += BombConfig.snoozeDuration;
      alarmScreen.cleanUp();
      clockScreen.cleanUp();
      try {
        if (null != boomPlayer) boomPlayer.stop();
      } catch (Exception ex) {
        ex.printStackTrace();
      }
      disp.setCurrent(clockScreen);
    }else if (cmd == cmdStop){
      snoozeTime = 0;
      penalty = 0;
      isDefused = true;
      try {
        if (null != boomPlayer) boomPlayer.stop();
      } catch (Exception ex) {
        ex.printStackTrace();
      }
      disp.setCurrent(clockScreen);
    }
  }
  
  private void updateConfigListItems(){
    for (int i=0;i<7;i++){
      AlarmTime at = bombConfig.getAlarmTime(i);
      String itemText = BombUtils.addLeadingZeros(at.hour(), 2) + ":" + BombUtils.addLeadingZeros(at.minute(), 2);
      itemText = itemText + " - " + BombUtils.weekDayNames[i];
      configurationForm.setItemText(i, itemText);
      configurationForm.setItemSelected(i, bombConfig.getAlarmEnableFlag(i));
    }  
  }
  
}